
const nodeAbi  = require('node-abi');
const execSync = require('child_process').execSync;

const archs = ['x64', 'ia32'];

const targets = archs.reduce((results, arch) => results.concat(
	nodeAbi.allTargets
		//.filter(target => (Number(target.abi) >= 47) && (Number(target.abi) <= 64) && (target.runtime !== 'node-webkit'))
		.map(target => ({ target: target.target, runtime: target.runtime, arch }))
), []);

const results = targets.map(target => {
	const command = `npx prebuild --target ${target.target} --runtime ${target.runtime} --strip --arch ${target.arch}`;
	try {
		execSync(command, { stdio: 'pipe' });
		console.log(`built ${target.target} ${target.runtime} ${target.arch}`);
		return true;
	} catch (err) {
		console.error(err.stderr.toString());
		return false;
	}
});

/*
const tasks = targets.map(target => Promise.all(archs.map(arch => Promise.all(targets.map(target => new Promise((resolve, reject) => {
	const command = `npx prebuild --target ${target.target} --runtime ${target.runtime} --strip --arch ${arch}`;
	exec(command, (err, stdin, stdout) => {
		if (!err) {
			resolve(stdout.toString());
		} else {
			reject(err);
		}
	});
}))))));

tasks
	.then(() => console.log('okay.'))
	.catch(err => console.error(err));
*/
